From c656dfd01e8cfb6322717fca3c976f565648fc56 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Tue, 3 Jul 2018 23:00:15 +0200
Subject: [PATCH] WIP mtree: Sync with NetBSD 20180703

---
 usr.sbin/mtree/Makefile     |  19 +-
 usr.sbin/mtree/compare.c    | 599 ++++++++++++++++--------
 usr.sbin/mtree/crc.c        | 163 +++++++
 usr.sbin/mtree/create.c     | 525 ++++++++++++---------
 usr.sbin/mtree/excludes.c   |  66 +--
 usr.sbin/mtree/extern.h     |  72 ++-
 usr.sbin/mtree/getid.c      | 446 ++++++++++++++++++
 usr.sbin/mtree/misc.c       | 255 +++++++++--
 usr.sbin/mtree/mtree.8      | 819 +++++++++++++++++++++++++--------
 usr.sbin/mtree/mtree.c      | 244 ++++++++--
 usr.sbin/mtree/mtree.h      | 128 ++++--
 usr.sbin/mtree/only.c       | 153 +++++++
 usr.sbin/mtree/pack_dev.c   | 290 ++++++++++++
 usr.sbin/mtree/pack_dev.h   |  47 ++
 usr.sbin/mtree/spec.c       | 886 +++++++++++++++++++++++++++++-------
 usr.sbin/mtree/specspec.c   | 273 +++++++++++
 usr.sbin/mtree/stat_flags.c | 187 ++++++++
 usr.sbin/mtree/verify.c     | 214 ++++++---
 18 files changed, 4403 insertions(+), 983 deletions(-)
 create mode 100644 usr.sbin/mtree/crc.c
 create mode 100644 usr.sbin/mtree/getid.c
 create mode 100644 usr.sbin/mtree/only.c
 create mode 100644 usr.sbin/mtree/pack_dev.c
 create mode 100644 usr.sbin/mtree/pack_dev.h
 create mode 100644 usr.sbin/mtree/specspec.c
 create mode 100644 usr.sbin/mtree/stat_flags.c

diff --git a/usr.sbin/mtree/Makefile b/usr.sbin/mtree/Makefile
index 0c352936d8..3feb4a77d5 100644
--- a/usr.sbin/mtree/Makefile
+++ b/usr.sbin/mtree/Makefile
@@ -1,20 +1,25 @@
-#	From: @(#)Makefile	8.1 (Berkeley) 6/6/93
-# $FreeBSD: src/usr.sbin/mtree/Makefile,v 1.15.2.5 2001/09/24 15:44:22 ru Exp $
+#	$NetBSD: Makefile,v 1.34 2013/02/03 19:15:16 christos Exp $
+#	from: @(#)Makefile	8.2 (Berkeley) 4/27/95
 
 .PATH: ${.CURDIR}/../../usr.bin/cksum
 .PATH: ${.CURDIR}/../../sbin/md5
 
 PROG=	mtree
 MAN=	mtree.8
-SRCS=	compare.c crc.c create.c excludes.c misc.c mtree.c spec.c verify.c
+SRCS=	compare.c crc.c create.c excludes.c misc.c mtree.c spec.c specspec.c \
+	verify.c getid.c only.c
+SRCS+=	pack_dev.c stat_flags.c
 
-.if !defined(BOOTSTRAPPING)
 SRCS+=	sha1hl.c
 CFLAGS+= -DUSE_MD5 -DUSE_SHA1 -DUSE_RMD160
-DPADD=  ${LIBMD} ${LIBCRYPTO}
-LDADD=  -lmd -lprivate_crypto
+DPADD=  ${LIBMD} ${LIBCRYPTO} ${LIBUTIL}
+LDADD=  -lmd -lprivate_crypto -lutil
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
 CFLAGS+= 	-I${.CURDIR}/../../crypto/libressl/include
-.endif
+
+CFLAGS+=-I${_SHLIBDIRPREFIX}/usr/include/priv -I${.CURDIR}/../../sbin/md5
+CFLAGS+=-DNO_RMD160
+
+#CFLAGS+=-DDEBUG
 
 .include <bsd.prog.mk>
diff --git a/usr.sbin/mtree/compare.c b/usr.sbin/mtree/compare.c
index 28ac909a47..b42f04443e 100644
--- a/usr.sbin/mtree/compare.c
+++ b/usr.sbin/mtree/compare.c
@@ -1,3 +1,5 @@
+/*	$NetBSD: compare.c,v 1.58 2013/11/21 18:39:50 christos Exp $	*/
+
 /*-
  * Copyright (c) 1989, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -25,51 +27,124 @@
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
- *
- * @(#)compare.c	8.1 (Berkeley) 6/6/93
- * $FreeBSD: src/usr.sbin/mtree/compare.c,v 1.15.2.4 2003/05/07 17:55:17 tobez Exp $
  */
 
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+#if defined(__RCSID) && !defined(lint)
+#if 0
+static char sccsid[] = "@(#)compare.c	8.1 (Berkeley) 6/6/93";
+#else
+__RCSID("$NetBSD: compare.c,v 1.58 2013/11/21 18:39:50 christos Exp $");
+#endif
+#endif /* not lint */
+
 #include <sys/param.h>
 #include <sys/stat.h>
-#include <err.h>
+
 #include <errno.h>
 #include <fcntl.h>
-#include <fts.h>
-#ifdef USE_MD5
+#include <stdio.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <time.h>
+#include <unistd.h>
+
+#ifndef NO_MD5
 #include <md5.h>
 #endif
-#ifdef USE_SHA1
+#ifndef NO_RMD160
+#include <rmd160.h>
+#endif
+#ifndef NO_SHA1
 #include <sha.h>
-#include "../../sbin/md5/sha1hl.h"
+#include <sha1hl.h>
 #endif
-#ifdef USE_RMD160
-#include <ripemd.h>
+#ifndef NO_SHA2
+#include <sha256.h>
+#include <sha512.h>
 #endif
-#include <stdio.h>
-#include <time.h>
-#include <unistd.h>
-#include "mtree.h"
-#include "extern.h"
 
-static const char *ftype(u_int);
+#include "extern.h"
 
 #define	INDENTNAMELEN	8
-#define	LABEL \
-	if (!label++) { \
-		len = printf("%s changed\n", RP(p)); \
-		tab = "\t"; \
+#define MARK								\
+do {									\
+	if (flavor == F_FREEBSD9) {					\
+		len = printf("%s changed\n", RP(p));			\
+		tab = "\t";						\
+	} else {							\
+		len = printf("%s: ", RP(p));				\
+		if (len > INDENTNAMELEN) {				\
+			tab = "\t";					\
+			printf("\n");					\
+		} else {						\
+			tab = "";					\
+			printf("%*s", INDENTNAMELEN - (int)len, "");	\
+		}							\
+	}								\
+} while (0)
+#define	LABEL if (!label++) MARK
+
+#if HAVE_STRUCT_STAT_ST_FLAGS
+
+
+#define CHANGEFLAGS							\
+	if (flags != p->fts_statp->st_flags) {				\
+		char *sf;						\
+		if (!label) {						\
+			MARK;						\
+			sf = flags_to_string(p->fts_statp->st_flags, "none"); \
+			printf("%sflags (\"%s\"", tab, sf);		\
+			free(sf);					\
+		}							\
+		if (lchflags(p->fts_accpath, flags)) {			\
+			label++;					\
+			printf(", not modified: %s)\n",			\
+			    strerror(errno));				\
+		} else {						\
+			sf = flags_to_string(flags, "none");		\
+			printf(", modified to \"%s\")\n", sf);		\
+			free(sf);					\
+		}							\
 	}
 
+/* SETFLAGS:
+ * given pflags, additionally set those flags specified in s->st_flags and
+ * selected by mask (the other flags are left unchanged).
+ */
+#define SETFLAGS(pflags, mask)						\
+do {									\
+	flags = (s->st_flags & (mask)) | (pflags);			\
+	CHANGEFLAGS;							\
+} while (0)
+
+/* CLEARFLAGS:
+ * given pflags, reset the flags specified in s->st_flags and selected by mask
+ * (the other flags are left unchanged).
+ */
+#define CLEARFLAGS(pflags, mask)					\
+do {									\
+	flags = (~(s->st_flags & (mask)) & CH_MASK) & (pflags);		\
+	CHANGEFLAGS;							\
+} while (0)
+#endif	/* HAVE_STRUCT_STAT_ST_FLAGS */
+
 int
 compare(NODE *s, FTSENT *p)
 {
-	uint32_t val;
-	off_t len;
+	u_int32_t len, val, flags;
 	int fd, label;
-	char *cp, *fflags;
-	const char *tab = "";
+	const char *cp, *tab;
+#if !defined(NO_MD5) || !defined(NO_RMD160) || !defined(NO_SHA1) || !defined(NO_SHA2)
+	char *digestbuf;
+#endif
 
+	tab = NULL;
 	label = 0;
 	switch(s->type) {
 	case F_BLOCK:
@@ -96,88 +171,237 @@ compare(NODE *s, FTSENT *p)
 		if (!S_ISLNK(p->fts_statp->st_mode))
 			goto typeerr;
 		break;
+#ifdef S_ISSOCK
 	case F_SOCK:
-		if (!S_ISSOCK(p->fts_statp->st_mode)) {
-typeerr:		LABEL;
-			printf("\ttype expected %s found %s\n",
-			    ftype(s->type), inotype(p->fts_statp->st_mode));
-			return (label);
-		}
+		if (!S_ISSOCK(p->fts_statp->st_mode))
+			goto typeerr;
 		break;
+#endif
+typeerr:		LABEL;
+		printf(flavor == F_FREEBSD9 ?
+		    "\ttype expected %s found %s\n" : "\ttype (%s, %s)\n",
+		    nodetype(s->type), inotype(p->fts_statp->st_mode));
+		return (label);
+	}
+	if (mtree_Wflag)
+		goto afterpermwhack;
+#if HAVE_STRUCT_STAT_ST_FLAGS
+	if (iflag && !uflag) {
+		if (s->flags & F_FLAGS)
+		    SETFLAGS(p->fts_statp->st_flags, SP_FLGS);
+		return (label);
+        }
+	if (mflag && !uflag) {
+		if (s->flags & F_FLAGS)
+		    CLEARFLAGS(p->fts_statp->st_flags, SP_FLGS);
+		return (label);
+        }
+#endif
+	if (s->flags & F_DEV &&
+	    (s->type == F_BLOCK || s->type == F_CHAR) &&
+	    s->st_rdev != p->fts_statp->st_rdev) {
+		LABEL;
+		printf(flavor == F_FREEBSD9 ?
+		    "%sdevice expected %#jx found %#jx" :
+		    "%sdevice (%#jx, %#jx",
+		    tab, (uintmax_t)s->st_rdev,
+		    (uintmax_t)p->fts_statp->st_rdev);
+		if (uflag) {
+			if ((unlink(p->fts_accpath) == -1) ||
+			    (mknod(p->fts_accpath,
+			      s->st_mode | nodetoino(s->type),
+			      s->st_rdev) == -1) ||
+			    (lchown(p->fts_accpath, p->fts_statp->st_uid,
+			      p->fts_statp->st_gid) == -1) )
+				printf(", not modified: %s%s\n",
+				    strerror(errno),
+				    flavor == F_FREEBSD9 ? "" : ")");
+			 else
+				printf(", modified%s\n",
+				    flavor == F_FREEBSD9 ? "" : ")");
+		} else
+			printf(")\n");
+		tab = "\t";
 	}
 	/* Set the uid/gid first, then set the mode. */
 	if (s->flags & (F_UID | F_UNAME) && s->st_uid != p->fts_statp->st_uid) {
 		LABEL;
-		printf("%suser expected %lu found %lu",
+		printf(flavor == F_FREEBSD9 ?
+		    "%suser expected %lu found %lu" : "%suser (%lu, %lu",
 		    tab, (u_long)s->st_uid, (u_long)p->fts_statp->st_uid);
-		if (uflag)
-			if (chown(p->fts_accpath, s->st_uid, -1))
-				printf(" not modified: %s\n",
-				    strerror(errno));
+		if (uflag) {
+			if (lchown(p->fts_accpath, s->st_uid, -1))
+				printf(", not modified: %s%s\n",
+				    strerror(errno),
+				    flavor == F_FREEBSD9 ? "" : ")");
 			else
-				printf(" modified\n");
-		else
-			printf("\n");
+				printf(", modified%s\n",
+				    flavor == F_FREEBSD9 ? "" : ")");
+		} else
+			printf(")\n");
 		tab = "\t";
 	}
 	if (s->flags & (F_GID | F_GNAME) && s->st_gid != p->fts_statp->st_gid) {
 		LABEL;
-		printf("%sgid expected %lu found %lu",
+		printf(flavor == F_FREEBSD9 ?
+		    "%sgid expected %lu found %lu" : "%sgid (%lu, %lu",
 		    tab, (u_long)s->st_gid, (u_long)p->fts_statp->st_gid);
-		if (uflag)
-			if (chown(p->fts_accpath, -1, s->st_gid))
-				printf(" not modified: %s\n",
-				    strerror(errno));
+		if (uflag) {
+			if (lchown(p->fts_accpath, -1, s->st_gid))
+				printf(", not modified: %s%s\n",
+				    strerror(errno),
+				    flavor == F_FREEBSD9 ? "" : ")");
 			else
-				printf(" modified\n");
+				printf(", modified%s\n",
+				    flavor == F_FREEBSD9 ? "" : ")");
+		}
 		else
-			printf("\n");
+			printf(")\n");
 		tab = "\t";
 	}
 	if (s->flags & F_MODE &&
-	    !S_ISLNK(p->fts_statp->st_mode) &&
 	    s->st_mode != (p->fts_statp->st_mode & MBITS)) {
+		if (lflag) {
+			mode_t tmode, mode;
+
+			tmode = s->st_mode;
+			mode = p->fts_statp->st_mode & MBITS;
+			/*
+			 * if none of the suid/sgid/etc bits are set,
+			 * then if the mode is a subset of the target,
+			 * skip.
+			 */
+			if (!((tmode & ~(S_IRWXU|S_IRWXG|S_IRWXO)) ||
+			    (mode & ~(S_IRWXU|S_IRWXG|S_IRWXO))))
+				if ((mode | tmode) == tmode)
+					goto skip;
+		}
+
 		LABEL;
-		printf("%spermissions expected %#o found %#o",
-		    tab, s->st_mode, p->fts_statp->st_mode & MBITS);
-		if (uflag)
-			if (chmod(p->fts_accpath, s->st_mode))
-				printf(" not modified: %s\n",
-				    strerror(errno));
+		printf(flavor == F_FREEBSD9 ?
+		    "%spermissions expcted %#lo found %#lo" :
+		    "%spermissions (%#lo, %#lo",
+		    tab, (u_long)s->st_mode,
+		    (u_long)p->fts_statp->st_mode & MBITS);
+		if (uflag) {
+			if (lchmod(p->fts_accpath, s->st_mode))
+				printf(", not modified: %s%s\n",
+				    strerror(errno),
+				    flavor == F_FREEBSD9 ? "" : ")");
 			else
-				printf(" modified\n");
+				printf(", modified%s\n",
+				    flavor == F_FREEBSD9 ? "" : ")");
+		}
 		else
-			printf("\n");
+			printf(")\n");
 		tab = "\t";
+	skip:	;
 	}
 	if (s->flags & F_NLINK && s->type != F_DIR &&
 	    s->st_nlink != p->fts_statp->st_nlink) {
 		LABEL;
-		printf("%slink_count expected %u found %u\n",
-		    tab, s->st_nlink, p->fts_statp->st_nlink);
+		printf(flavor == F_FREEBSD9 ?
+		    "%slink count expected %lu found %lu\n" :
+		    "%slink count (%lu, %lu)\n",
+		    tab, (u_long)s->st_nlink, (u_long)p->fts_statp->st_nlink);
 		tab = "\t";
 	}
-	if (s->flags & F_SIZE && s->st_size != p->fts_statp->st_size &&
-		!S_ISDIR(p->fts_statp->st_mode)) {
+	if (s->flags & F_SIZE && s->st_size != p->fts_statp->st_size) {
 		LABEL;
-		printf("%ssize expected %jd found %jd\n", tab,
-		    (intmax_t)s->st_size, (intmax_t)p->fts_statp->st_size);
+		printf(flavor == F_FREEBSD9 ?
+		    "%ssize expected %ju found %ju\n" : "%ssize (%ju, %ju)\n",
+		    tab, (uintmax_t)s->st_size,
+		    (uintmax_t)p->fts_statp->st_size);
 		tab = "\t";
 	}
 	/*
 	 * XXX
-	 * Catches nano-second differences, but doesn't display them.
+	 * Since utimes(2) only takes a timeval, there's no point in
+	 * comparing the low bits of the timespec nanosecond field.  This
+	 * will only result in mismatches that we can never fix.
+	 *
+	 * Doesn't display microsecond differences.
 	 */
-	if ((s->flags & F_TIME) &&
-	     ((s->st_mtimespec.tv_sec != p->fts_statp->st_mtimespec.tv_sec) ||
-	     (s->st_mtimespec.tv_nsec != p->fts_statp->st_mtimespec.tv_nsec))) {
-		LABEL;
-		printf("%smodification time expected %.24s ",
-		    tab, ctime(&s->st_mtimespec.tv_sec));
-		printf("found %.24s\n",
-		    ctime(&p->fts_statp->st_mtimespec.tv_sec));
+	if (s->flags & F_TIME) {
+		struct timeval tv[2];
+		struct stat *ps = p->fts_statp;
+		time_t smtime = s->st_mtimespec.tv_sec;
+
+#if defined(BSD4_4) && !defined(HAVE_NBTOOL_CONFIG_H)
+		time_t pmtime = ps->st_mtimespec.tv_sec;
+
+		TIMESPEC_TO_TIMEVAL(&tv[0], &s->st_mtimespec);
+		TIMESPEC_TO_TIMEVAL(&tv[1], &ps->st_mtimespec);
+#else
+		time_t pmtime = (time_t)ps->st_mtime;
+
+		tv[0].tv_sec = smtime;
+		tv[0].tv_usec = 0;
+		tv[1].tv_sec = pmtime;
+		tv[1].tv_usec = 0;
+#endif
+
+		if (tv[0].tv_sec != tv[1].tv_sec ||
+		    tv[0].tv_usec != tv[1].tv_usec) {
+			LABEL;
+			printf(flavor == F_FREEBSD9 ?
+			    "%smodification time expected %.24s found " :
+			    "%smodification time (%.24s, ",
+			    tab, ctime(&smtime));
+			printf("%.24s", ctime(&pmtime));
+			if (tflag) {
+				tv[1] = tv[0];
+				if (utimes(p->fts_accpath, tv))
+					printf(", not modified: %s%s\n",
+					    strerror(errno),
+					    flavor == F_FREEBSD9 ? "" : ")");
+				else
+					printf(", modified%s\n",
+					    flavor == F_FREEBSD9 ? "" : ")");
+			} else
+				printf("%s\n", flavor == F_FREEBSD9 ? "" : ")");
+			tab = "\t";
+		}
+	}
+#if HAVE_STRUCT_STAT_ST_FLAGS
+	/*
+	 * XXX
+	 * since lchflags(2) will reset file times, the utimes() above
+	 * may have been useless!  oh well, we'd rather have correct
+	 * flags, rather than times?
+	 */
+        if ((s->flags & F_FLAGS) && ((s->st_flags != p->fts_statp->st_flags)
+	    || mflag || iflag)) {
+		if (s->st_flags != p->fts_statp->st_flags) {
+			char *f_s;
+			LABEL;
+			f_s = flags_to_string(s->st_flags, "none");
+			printf(flavor == F_FREEBSD9 ?
+			    "%sflags expected \"%s\" found " :
+			    "%sflags (\"%s\" is not ", tab, f_s);
+			free(f_s);
+			f_s = flags_to_string(p->fts_statp->st_flags, "none");
+			printf("\"%s\"", f_s);
+			free(f_s);
+		}
+		if (uflag) {
+			if (iflag)
+				SETFLAGS(0, CH_MASK);
+			else if (mflag)
+				CLEARFLAGS(0, SP_FLGS);
+			else
+				SETFLAGS(0, (~SP_FLGS & CH_MASK));
+		} else
+			printf("%s\n", flavor == F_FREEBSD9 ? "" : ")");
 		tab = "\t";
 	}
+#endif	/* HAVE_STRUCT_STAT_ST_FLAGS */
+
+	/*
+	 * from this point, no more permission checking or whacking
+	 * occurs, only checking of stuff like checksums and symlinks.
+	 */
+ afterpermwhack:
 	if (s->flags & F_CKSUM) {
 		if ((fd = open(p->fts_accpath, O_RDONLY, 0)) < 0) {
 			LABEL;
@@ -194,158 +418,163 @@ typeerr:		LABEL;
 			close(fd);
 			if (s->cksum != val) {
 				LABEL;
-				printf("%scksum expected %lu found %u\n",
-				    tab, s->cksum, val);
-				tab = "\t";
+				printf(flavor == F_FREEBSD9 ?
+				    "%scksum expected %lu found %lu\n" :
+				    "%scksum (%lu, %lu)\n",
+				    tab, s->cksum, (unsigned long)val);
 			}
+			tab = "\t";
 		}
 	}
-	/*
-	 * XXX
-	 * since chflags(2) will reset file times, the utimes() above
-	 * may have been useless!  oh well, we'd rather have correct
-	 * flags, rather than times?
-	 */
-	if ((s->flags & F_FLAGS) && s->st_flags != p->fts_statp->st_flags) {
-		LABEL;
-		fflags = flags_to_string(s->st_flags);
-		printf("%sflags expected \"%s\"", tab, fflags);
-		free(fflags);
-
-		fflags = flags_to_string(p->fts_statp->st_flags);
-		printf(" found \"%s\"", fflags);
-		free(fflags);
-
-		if (uflag)
-			if (chflags(p->fts_accpath, s->st_flags))
-				printf(" not modified: %s\n",
-				    strerror(errno));
-			else
-				printf(" modified\n");
-		else
-			printf("\n");
-		tab = "\t";
-	}
-#ifdef USE_MD5
+#ifndef NO_MD5
 	if (s->flags & F_MD5) {
-		char *new_digest, buf[33];
-
-		new_digest = MD5File(p->fts_accpath, buf);
-		if (!new_digest) {
+		if ((digestbuf = MD5File(p->fts_accpath, NULL)) == NULL) {
 			LABEL;
-			printf("%sMD5: %s: %s\n", tab, p->fts_accpath,
-			       strerror(errno));
+			printf("%s%s: %s: %s\n",
+			    tab, MD5KEY, p->fts_accpath, strerror(errno));
+			tab = "\t";
+		} else {
+			if (strcmp(s->md5digest, digestbuf)) {
+				LABEL;
+				printf(flavor == F_FREEBSD9 ?
+				    "%s%s expected %s found %s\n" :
+				    "%s%s (0x%s, 0x%s)\n",
+				    tab, MD5KEY, s->md5digest, digestbuf);
+			}
 			tab = "\t";
-		} else if (strcmp(new_digest, s->md5digest)) {
+			free(digestbuf);
+		}
+	}
+#endif	/* ! NO_MD5 */
+#ifndef NO_RMD160
+	if (s->flags & F_RMD160) {
+		if ((digestbuf = RMD160_File(p->fts_accpath, NULL)) == NULL) {
 			LABEL;
-			printf("%sMD5 expected %s found %s\n", tab, s->md5digest,
-			       new_digest);
+			printf("%s%s: %s: %s\n",
+			    tab, RMD160KEY, p->fts_accpath, strerror(errno));
+			tab = "\t";
+		} else {
+			if (strcmp(s->rmd160digest, digestbuf)) {
+				LABEL;
+				printf(flavor == F_FREEBSD9 ?
+				    "%s%s expected %s found %s\n" :
+				    "%s%s (0x%s, 0x%s)\n",
+				    tab, RMD160KEY, s->rmd160digest, digestbuf);
+			}
 			tab = "\t";
+			free(digestbuf);
 		}
 	}
-#endif /* MD5 */
-#ifdef USE_SHA1
+#endif	/* ! NO_RMD160 */
+#ifndef NO_SHA1
 	if (s->flags & F_SHA1) {
-		char *new_digest, buf[41];
-
-		new_digest = SHA1_File(p->fts_accpath, buf);
-		if (!new_digest) {
+		if ((digestbuf = SHA1_File(p->fts_accpath, NULL)) == NULL) {
 			LABEL;
-			printf("%sSHA-1: %s: %s\n", tab, p->fts_accpath,
-			       strerror(errno));
+			printf("%s%s: %s: %s\n",
+			    tab, SHA1KEY, p->fts_accpath, strerror(errno));
+			tab = "\t";
+		} else {
+			if (strcmp(s->sha1digest, digestbuf)) {
+				LABEL;
+				printf(flavor == F_FREEBSD9 ? 
+				    "%s%s expected %s found %s\n" :
+				    "%s%s (0x%s, 0x%s)\n",
+				    tab, SHA1KEY, s->sha1digest, digestbuf);
+			}
 			tab = "\t";
-		} else if (strcmp(new_digest, s->sha1digest)) {
+			free(digestbuf);
+		}
+	}
+#endif	/* ! NO_SHA1 */
+#ifndef NO_SHA2
+	if (s->flags & F_SHA256) {
+		if ((digestbuf = SHA256_File(p->fts_accpath, NULL)) == NULL) {
 			LABEL;
-			printf("%sSHA-1 expected %s found %s\n", 
-			       tab, s->sha1digest, new_digest);
+			printf("%s%s: %s: %s\n",
+			    tab, SHA256KEY, p->fts_accpath, strerror(errno));
+			tab = "\t";
+		} else {
+			if (strcmp(s->sha256digest, digestbuf)) {
+				LABEL;
+				printf(flavor == F_FREEBSD9 ? 
+				    "%s%s expected %s found %s\n" :
+				    "%s%s (0x%s, 0x%s)\n",
+				    tab, SHA256KEY, s->sha256digest, digestbuf);
+			}
 			tab = "\t";
+			free(digestbuf);
 		}
 	}
-#endif /* SHA1 */
-#ifdef USE_RMD160
-	if (s->flags & F_RMD160) {
-		char *new_digest, buf[41];
-
-		new_digest = RIPEMD160_File(p->fts_accpath, buf);
-		if (!new_digest) {
+#if 0 /* XXX __DragonFly__ */
+#ifdef SHA384_BLOCK_LENGTH
+	if (s->flags & F_SHA384) {
+		if ((digestbuf = SHA384_File(p->fts_accpath, NULL)) == NULL) {
 			LABEL;
-			printf("%sRIPEMD160: %s: %s\n", tab,
-			       p->fts_accpath, strerror(errno));
+			printf("%s%s: %s: %s\n",
+			    tab, SHA384KEY, p->fts_accpath, strerror(errno));
+			tab = "\t";
+		} else {
+			if (strcmp(s->sha384digest, digestbuf)) {
+				LABEL;
+				printf(flavor == F_FREEBSD9 ? 
+				    "%s%s expected %s found %s\n" :
+				    "%s%s (0x%s, 0x%s)\n",
+				    tab, SHA384KEY, s->sha384digest, digestbuf);
+			}
 			tab = "\t";
-		} else if (strcmp(new_digest, s->rmd160digest)) {
+			free(digestbuf);
+		}
+	}
+#endif
+#endif
+	if (s->flags & F_SHA512) {
+		if ((digestbuf = SHA512_File(p->fts_accpath, NULL)) == NULL) {
 			LABEL;
-			printf("%sRIPEMD160 expected %s found %s\n",
-			       tab, s->rmd160digest, new_digest);
+			printf("%s%s: %s: %s\n",
+			    tab, SHA512KEY, p->fts_accpath, strerror(errno));
+			tab = "\t";
+		} else {
+			if (strcmp(s->sha512digest, digestbuf)) {
+				LABEL;
+				printf(flavor == F_FREEBSD9 ? 
+				    "%s%s expected %s found %s\n" :
+				    "%s%s (0x%s, 0x%s)\n",
+				    tab, SHA512KEY, s->sha512digest, digestbuf);
+			}
 			tab = "\t";
+			free(digestbuf);
 		}
 	}
-#endif /* RMD160 */
-
+#endif	/* ! NO_SHA2 */
 	if (s->flags & F_SLINK &&
 	    strcmp(cp = rlink(p->fts_accpath), s->slink)) {
 		LABEL;
-		printf("%slink_ref expected %s found %s\n",
-		      tab, s->slink, cp);
+		printf(flavor == F_FREEBSD9 ? 
+		    "%slink ref expected %s found %s" :
+		    "%slink ref (%s, %s", tab, cp, s->slink);
+		if (uflag) {
+			if ((unlink(p->fts_accpath) == -1) ||
+			    (symlink(s->slink, p->fts_accpath) == -1) )
+				printf(", not modified: %s%s\n",
+				    strerror(errno),
+				    flavor == F_FREEBSD9 ? "" : ")");
+			else
+				printf(", modified%s\n",
+				    flavor == F_FREEBSD9 ? "" : ")");
+		} else
+			printf("%s\n", flavor == F_FREEBSD9 ? "" : ")");
 	}
 	return (label);
 }
 
 const char *
-inotype(u_int type)
-{
-	switch(type & S_IFMT) {
-	case S_IFBLK:
-		return ("block");
-	case S_IFCHR:
-		return ("char");
-	case S_IFDIR:
-		return ("dir");
-	case S_IFIFO:
-		return ("fifo");
-	case S_IFREG:
-		return ("file");
-	case S_IFLNK:
-		return ("link");
-	case S_IFSOCK:
-		return ("socket");
-	default:
-		return ("unknown");
-	}
-	/* NOTREACHED */
-}
-
-static const char *
-ftype(u_int type)
-{
-	switch(type) {
-	case F_BLOCK:
-		return ("block");
-	case F_CHAR:
-		return ("char");
-	case F_DIR:
-		return ("dir");
-	case F_FIFO:
-		return ("fifo");
-	case F_FILE:
-		return ("file");
-	case F_LINK:
-		return ("link");
-	case F_SOCK:
-		return ("socket");
-	default:
-		return ("unknown");
-	}
-	/* NOTREACHED */
-}
-
-char *
-rlink(char *name)
+rlink(const char *name)
 {
 	static char lbuf[MAXPATHLEN];
 	int len;
 
 	if ((len = readlink(name, lbuf, sizeof(lbuf) - 1)) == -1)
-		err(1, "line %d: %s", lineno, name);
+		mtree_err("%s: %s", name, strerror(errno));
 	lbuf[len] = '\0';
 	return (lbuf);
 }
diff --git a/usr.sbin/mtree/crc.c b/usr.sbin/mtree/crc.c
new file mode 100644
index 0000000000..4eac66e5b9
--- /dev/null
+++ b/usr.sbin/mtree/crc.c
@@ -0,0 +1,163 @@
+/*	$NetBSD: crc.c,v 1.9 2012/10/05 00:40:51 christos Exp $	*/
+
+/*-
+ * Copyright (c) 1991, 1993
+ *	The Regents of the University of California.  All rights reserved.
+ *
+ * This code is derived from software contributed to Berkeley by
+ * James W. Williams of NASA Goddard Space Flight Center.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#if HAVE_NBTOOL_CONFIG_H
+#include "nbtool_config.h"
+#endif
+
+#include <sys/cdefs.h>
+#if defined(__RCSID) && !defined(lint)
+#if 0
+static char sccsid[] = "@(#)crc.c	8.1 (Berkeley) 6/17/93";
+#else
+__RCSID("$NetBSD: crc.c,v 1.9 2012/10/05 00:40:51 christos Exp $");
+#endif
+#endif /* not lint */
+
+#include <sys/types.h>
+
+#include <stdio.h>
+#include <time.h>
+#include <unistd.h>
+
+#include "extern.h"
+
+static const u_int32_t crctab[] = {
+	0x0,
+	0x04c11db7, 0x09823b6e, 0x0d4326d9, 0x130476dc, 0x17c56b6b,
+	0x1a864db2, 0x1e475005, 0x2608edb8, 0x22c9f00f, 0x2f8ad6d6,
+	0x2b4bcb61, 0x350c9b64, 0x31cd86d3, 0x3c8ea00a, 0x384fbdbd,
+	0x4c11db70, 0x48d0c6c7, 0x4593e01e, 0x4152fda9, 0x5f15adac,
+	0x5bd4b01b, 0x569796c2, 0x52568b75, 0x6a1936c8, 0x6ed82b7f,
+	0x639b0da6, 0x675a1011, 0x791d4014, 0x7ddc5da3, 0x709f7b7a,
+	0x745e66cd, 0x9823b6e0, 0x9ce2ab57, 0x91a18d8e, 0x95609039,
+	0x8b27c03c, 0x8fe6dd8b, 0x82a5fb52, 0x8664e6e5, 0xbe2b5b58,
+	0xbaea46ef, 0xb7a96036, 0xb3687d81, 0xad2f2d84, 0xa9ee3033,
+	0xa4ad16ea, 0xa06c0b5d, 0xd4326d90, 0xd0f37027, 0xddb056fe,
+	0xd9714b49, 0xc7361b4c, 0xc3f706fb, 0xceb42022, 0xca753d95,
+	0xf23a8028, 0xf6fb9d9f, 0xfbb8bb46, 0xff79a6f1, 0xe13ef6f4,
+	0xe5ffeb43, 0xe8bccd9a, 0xec7dd02d, 0x34867077, 0x30476dc0,
+	0x3d044b19, 0x39c556ae, 0x278206ab, 0x23431b1c, 0x2e003dc5,
+	0x2ac12072, 0x128e9dcf, 0x164f8078, 0x1b0ca6a1, 0x1fcdbb16,
+	0x018aeb13, 0x054bf6a4, 0x0808d07d, 0x0cc9cdca, 0x7897ab07,
+	0x7c56b6b0, 0x71159069, 0x75d48dde, 0x6b93dddb, 0x6f52c06c,
+	0x6211e6b5, 0x66d0fb02, 0x5e9f46bf, 0x5a5e5b08, 0x571d7dd1,
+	0x53dc6066, 0x4d9b3063, 0x495a2dd4, 0x44190b0d, 0x40d816ba,
+	0xaca5c697, 0xa864db20, 0xa527fdf9, 0xa1e6e04e, 0xbfa1b04b,
+	0xbb60adfc, 0xb6238b25, 0xb2e29692, 0x8aad2b2f, 0x8e6c3698,
+	0x832f1041, 0x87ee0df6, 0x99a95df3, 0x9d684044, 0x902b669d,
+	0x94ea7b2a, 0xe0b41de7, 0xe4750050, 0xe9362689, 0xedf73b3e,
+	0xf3b06b3b, 0xf771768c, 0xfa325055, 0xfef34de2, 0xc6bcf05f,
+	0xc27dede8, 0xcf3ecb31, 0xcbffd686, 0xd5b88683, 0xd1799b34,
+	0xdc3abded, 0xd8fba05a, 0x690ce0ee, 0x6dcdfd59, 0x608edb80,
+	0x644fc637, 0x7a089632, 0x7ec98b85, 0x738aad5c, 0x774bb0eb,
+	0x4f040d56, 0x4bc510e1, 0x46863638, 0x42472b8f, 0x5c007b8a,
+	0x58c1663d, 0x558240e4, 0x51435d53, 0x251d3b9e, 0x21dc2629,
+	0x2c9f00f0, 0x285e1d47, 0x36194d42, 0x32d850f5, 0x3f9b762c,
+	0x3b5a6b9b, 0x0315d626, 0x07d4cb91, 0x0a97ed48, 0x0e56f0ff,
+	0x1011a0fa, 0x14d0bd4d, 0x19939b94, 0x1d528623, 0xf12f560e,
+	0xf5ee4bb9, 0xf8ad6d60, 0xfc6c70d7, 0xe22b20d2, 0xe6ea3d65,
+	0xeba91bbc, 0xef68060b, 0xd727bbb6, 0xd3e6a601, 0xdea580d8,
+	0xda649d6f, 0xc423cd6a, 0xc0e2d0dd, 0xcda1f604, 0xc960ebb3,
+	0xbd3e8d7e, 0xb9ff90c9, 0xb4bcb610, 0xb07daba7, 0xae3afba2,
+	0xaafbe615, 0xa7b8c0cc, 0xa379dd7b, 0x9b3660c6, 0x9ff77d71,
+	0x92b45ba8, 0x9675461f, 0x8832161a, 0x8cf30bad, 0x81b02d74,
+	0x857130c3, 0x5d8a9099, 0x594b8d2e, 0x5408abf7, 0x50c9b640,
+	0x4e8ee645, 0x4a4ffbf2, 0x470cdd2b, 0x43cdc09c, 0x7b827d21,
+	0x7f436096, 0x7200464f, 0x76c15bf8, 0x68860bfd, 0x6c47164a,
+	0x61043093, 0x65c52d24, 0x119b4be9, 0x155a565e, 0x18197087,
+	0x1cd86d30, 0x029f3d35, 0x065e2082, 0x0b1d065b, 0x0fdc1bec,
+	0x3793a651, 0x3352bbe6, 0x3e119d3f, 0x3ad08088, 0x2497d08d,
+	0x2056cd3a, 0x2d15ebe3, 0x29d4f654, 0xc5a92679, 0xc1683bce,
+	0xcc2b1d17, 0xc8ea00a0, 0xd6ad50a5, 0xd26c4d12, 0xdf2f6bcb,
+	0xdbee767c, 0xe3a1cbc1, 0xe760d676, 0xea23f0af, 0xeee2ed18,
+	0xf0a5bd1d, 0xf464a0aa, 0xf9278673, 0xfde69bc4, 0x89b8fd09,
+	0x8d79e0be, 0x803ac667, 0x84fbdbd0, 0x9abc8bd5, 0x9e7d9662,
+	0x933eb0bb, 0x97ffad0c, 0xafb010b1, 0xab710d06, 0xa6322bdf,
+	0xa2f33668, 0xbcb4666d, 0xb8757bda, 0xb5365d03, 0xb1f740b4
+};
+
+/*
+ * Compute a POSIX 1003.2 checksum.  This routine has been broken out so that
+ * other programs can use it.  It takes a file descriptor to read from and
+ * locations to store the crc and the number of bytes read.  It returns 0 on
+ * success and 1 on failure.  Errno is set on failure.
+ */
+u_int32_t crc_total = ~0;		/* The crc over a number of files. */
+
+int
+crc(int fd, u_int32_t *cval, u_int32_t *clen)
+{
+	u_char *p;
+	int nr;
+	u_int32_t thecrc, len;
+	u_int32_t crctot;
+	u_char buf[16 * 1024];
+
+#define	COMPUTE(var, ch)	(var) = (var) << 8 ^ crctab[(var) >> 24 ^ (ch)]
+
+	thecrc = len = crctot = 0;
+	if (sflag)
+		crctot = ~crc_total;
+	while ((nr = read(fd, buf, sizeof(buf))) > 0)
+		if (sflag) {
+			for (len += nr, p = buf; nr--; ++p) {
+				COMPUTE(thecrc, *p);
+				COMPUTE(crctot, *p);
+			}
+		} else {
+			for (len += nr, p = buf; nr--; ++p)
+				COMPUTE(thecrc, *p);
+		}
+	if (nr < 0)
+		return 1;
+
+	*clen = len;
+
+	/* Include the length of the file. */
+	if (sflag) {
+		for (; len != 0; len >>= 8) {
+			COMPUTE(thecrc, len & 0xff);
+			COMPUTE(crctot, len & 0xff);
+		}
+	} else {
+		for (; len != 0; len >>= 8)
+			COMPUTE(thecrc, len & 0xff);
+	}
+
+	*cval = ~thecrc;
+	if (sflag)
+		crc_total = ~crctot;
+	return 0;
+}
